import { TrieNode } from './TrieNode';
import { Sequence } from 'gensequence';
import * as Rx from 'rxjs/Rx';
export interface ExportOptions {
    base?: number;
    comment?: string;
}
/**
 * Serialize a TrieNode.
 * Note: This is destructive.  The node will no longer be usable.
 * Even though it is possible to preserve the trie, dealing with very large tries can consume a lot of memory.
 * Considering this is the last step before exporting, it was decided to let this be destructive.
 */
export declare function serializeTrie(root: TrieNode, options?: ExportOptions | number): Sequence<string>;
export declare function importTrieRx(lines: Rx.Observable<string>): Rx.Observable<TrieNode>;
