import { TrieNode } from './TrieNode';
export declare type Cost = number;
export declare type MaxCost = Cost;
export interface SuggestionResult {
    word: string;
    cost: Cost;
}
export declare function suggest(root: TrieNode, word: string, maxNumSuggestions?: number): SuggestionResult[];
export declare function genSuggestions(root: TrieNode, word: string, output: (suggestion: SuggestionResult) => MaxCost): void;
export declare function genCompoundableSuggestions(root: TrieNode, word: string, useCompounds: boolean, output: (suggestion: SuggestionResult) => MaxCost): void;
export interface SuggestionCollector {
    (suggestion: SuggestionResult): MaxCost;
    readonly suggestions: SuggestionResult[];
    readonly maxCost: number;
    readonly word: string;
}
export declare function suggestionCollector(word: string, maxNumSuggestions: number, filter?: (word: string) => boolean): SuggestionCollector;
